# coding: utf-8
require "french_populate/version"

class Populate

	# Load datas
	require "datas.rb"

	## VARIABLES ##
	$shortTitles = ["Mr", "Mlle", "Me"]
	$longTitles = ["Monsieur", "Mademoiselle", "Madame"]
	$emailExtension = ["com", "fr", "org", "net", "be"]
	$emailDNS = ["infonie", "aliceadsl", "tiscali", "free", "orange", "lycos"]
	
	## NAMES ##
	# Return a people title (short version. ex. "Mr")
	def GetShortTitle
		self.shortTitles.sample
	end

	# Return a people title (long version.ex. "Monsieur")
	def GetLongTitle
		self.longTitles.sample
	end

	# Return a fake last name
	def GetLastName 
		$namesBDD.sample.split("-").map(&:capitalize).join("-")
	end

	# Return a fake first name
	def GetFirstName
		$namesBDD.sample.split("-").map(&:capitalize).join("-")
	end

	# Return a fake full name (firstname + name)
	def GetFullName
		self.GetFirstName + " " + self.GetLastName
	end

	## PLACES ##
	# Return a fake street number
	def GetStreetNumber
		rand(1..150).to_s
	end

	# Return a fake street name
	def GetStreetName
		$streetsBDD.sample
	end

	# Return a fake zipcode
	def GetZipCode
		zipcode = rand(1000..95999).to_s
		if zipcode.length == 4
			zipcode = "0" + zipcode
		end
		zipcode
	end

	# Return a fake city
	def GetCity
		$citiesBDD.sample
	end

	# Return a fake country
	def GetCountry
		$countriesBDD.sample
	end

	# Return a fake full adsress (street number, street name, zipcode, city)
	def GetFullAddress
		self.GetStreetNumber + " " + self.GetStreetName + " " + self.GetZipCode + " " + self.GetCity 
	end

	# Return a fake full international address (street number, street name, zipcode, city, country)
	def GetFullInternationalAddress
		self.GetFullAddress + ", " + self.GetCountry
	end

	## INTERNET
	# Return a fake email
	def GetEmail
		(self.GetFirstName + "." + self.GetLastName + "@" + $emailDNS.sample + "." + $emailExtension.sample).downcase
	end

	# Return a fake username
	def GetUsername
		tempNumber = rand(1..9)
		# If the number is pair... or impair
		tempNumber % 2 == 0 ? tempNumber = 2 : tempNumber = 3
		tempEndNumber = case tempNumber
			when 2 then 4
			when 3 then 2
		end
		(self.GetFirstName.byteslice(1..tempNumber) + self.GetLastName.byteslice(1..tempNumber) + self.GetZipCode.byteslice(1..tempEndNumber)).downcase
	end

	# Return a fake unique username
	def GetUniqueUsername
		tempNumber = rand(1..9)
		# If the number is pair... or impair
		tempNumber % 2 == 0 ? tempNumber = 2 : tempNumber = 3
		(self.GetFirstName.byteslice(1..tempNumber) + self.GetLastName.byteslice(1..tempNumber) + Time.now.to_i.to_s.byteslice(5..9)).downcase
	end
end